VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFolderBrowser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
' ***************************************************************************************
'      Klasse zum auswhlen eines Ordners im Windows-Dialog
'
'  Autor: Stefan Maag
'  Datum: 26.06.2001
'  letzte Aenderung: 26.06.2001
'  Kontakt: maag@odn.de
' ***************************************************************************************

Option Explicit

Const BIF_RETURNONLYFSDIRS = &H1
Const BIF_DONTGOBELOWDOMAIN = &H2

'Const BIF_STATUSTEXT = &H4
'Const BIF_RETURNFSANCESTORS = &H8
'Const BIF_EDITBOX = &H10
'Const BIF_VALIDATE = &H20
'Const BIF_BROWSEFORCOMPUTER = &H1000
'Const BIF_BROWSEFORPRINTER = &H2000
'Const BIF_BROWSEINCLUDEFILES = &H4000

Private Type BrowseInfo
    hWndOwner      As Long
    pIDLRoot       As Long
    pszDisplayName As String
    lpszTitle      As String
    ulFlags        As Long
    lpfnCallback   As Long
    lParam         As Long
    iImage         As Long
End Type

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long

Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)

Dim tBrowseInfo As BrowseInfo

Dim m_Path As String             ' lokale Speichervariable fr vollstndigen Pfad
Dim m_FolderName As String       ' lokale Speichervaribale fr isolierten Ordnernamen

' ===========================================================================
'  hWndOwner :  gibt den Handle das aufrufenden Fensters an
'               wird hWndOwner nicht angegeben (=0), dann wird der
'               Auswahldialog nicht als Child-Prozess des aufrufenden
'               Fensters gestartet - also keine gemeinsame Aktivierung
'               Deaktivierung und bei NT/W2K entsprechende Rechtevergabe
'
'     hWndOwner kann auch noch beim Aufruf von .Show bergeben werden
' ===========================================================================

Public Property Get hWndOwner() As Long
   hWndOwner = tBrowseInfo.hWndOwner
End Property

Public Property Let hWndOwner(ByVal New_hWndOwner As Long)
   tBrowseInfo.hWndOwner = New_hWndOwner
End Property

' ===========================================================================
'  Title :  gibt die Beschriftung des Dialogfeldes an
' ===========================================================================

Public Property Get Title() As String
   Title = tBrowseInfo.lpszTitle
End Property

Public Property Let Title(ByVal New_Title As String)
   tBrowseInfo.lpszTitle = New_Title
End Property

' ===========================================================================
'  Name, Pfad des ausgewhlten Ordners
' ===========================================================================

Public Property Get Path() As String
   Path = m_Path
End Property

Public Property Get FolderName() As String
   FolderName = m_FolderName
End Property

' ===========================================================================
'  Show  :  zeigt den Ordnerdialog an
' ===========================================================================

Public Sub Show(Optional ByVal hWndOwner)
   Dim strPath As String
   Dim lngIDList As Long
   
   ' String fr Pfad mit 260 Zeichen anlegen
   strPath = Space(260)
   
   ' Wenn hWndOwnder an Show bergeben wurde, sonst nicht verndern
   If hWndOwner <> 0 Then
      tBrowseInfo.hWndOwner = hWndOwner
   End If
   
   With tBrowseInfo
      .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN
      .pszDisplayName = Space(260)     ' 260 Zeichen Leerstring
   End With
   
   lngIDList = SHBrowseForFolder(tBrowseInfo)
  
   If lngIDList <> 0 Then
      SHGetPathFromIDList lngIDList, strPath
      CoTaskMemFree lngIDList
      m_Path = ZTrim(strPath)
      m_FolderName = ZTrim(tBrowseInfo.pszDisplayName)
   End If
  
End Sub

' ===========================================================================
'  ZTrim : trennt den eigentlichen String aus den Fllzeichen eines
'          Strings mit fester Lnge
' ===========================================================================

Function ZTrim(S$) As String
    Dim p As Long
    p = InStr(S, vbNullChar)
    If p > 0 Then
        ZTrim = Left(S, p - 1)
    Else
        ZTrim = S
    End If
End Function

